import subprocess
import time
import multiprocessing

def run_process(command):
    while True:
        try:
            print(f"Running: {command}")
            subprocess.run(command, shell=True, check=True)
        except subprocess.CalledProcessError as e:
            print(f"Process stopped with error: {e}")
            time.sleep(10)

def main():
    processes = []

    # Add your command for each process
    commands = [
        "python broadcast.py broadcast_haloopdy.toml", 
        "python broadcast.py broadcast_haloopdy_webcam.toml",
        "python watch.py watch_fier.toml"
    ]

    # Start processes
    for cmd in commands:
        process = multiprocessing.Process(target=run_process, args=(cmd,))
        processes.append(process)
        process.start()

    try:
        # Monitor for key press to stop all processes
        input("Press Enter to stop all processes...")
    finally:
        # Terminate all processes when the key is pressed
        for process in processes:
            process.terminate()
            process.join()

if __name__ == "__main__":
    main()
